#include "myMath.h"

/* structure stockant les attributs d'une camera */
typedef struct sCamera{
	Vector o;
	Vector vise;
	Vector x;
	Vector y;
	Vector z;
	
	float angleOuverture;
	float rapportAspect;
	float planAvant;
	float planArriere;
	
	} tCamera, *pCamera;

/* cree une camera a partir de sa position et de son orientation ainsi 
   que de ses paramètres de projection */
pCamera creeCamera (	Vector eye, Vector look, Vector up,
                    	float angleOuverture,
			float rapportAspect,
			float planAvant,
			float planArriere);

/* multiplie la matrice courante par la matrice de perspective de la camera */
void perspectiveCamera (pCamera c);

/* place et oriente la camera avec un gluLooAt(...) */
void placeCamera (pCamera c);

/* avancer / reculer la camera */
void avanceCamera (pCamera c, float pas);

/* rotation autour de (oy) */
void walkRotYCamera (pCamera c, float pas);

/* rotation autour de (ox) */
void walkRotXCamera (pCamera c, float pas);

/* rotation autour de (oz) */
void walkRotZCamera (pCamera c, float pas);

/* positionne la camera a partir de sa position et de son orientation */
void positionCamera (pCamera c, Vector eye, Vector look, Vector up);
